unit DataMod;

interface

uses
  SysUtils, Windows, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables;

type
  TDataModule1 = class(TDataModule)
    Table1X_0: TFloatField;
    Table1X_1: TFloatField;
    Table1Y_0: TFloatField;
    Table1Y_1: TFloatField;
    Table1THRESHOLD: TSmallintField;
    Table1STEP: TSmallintField;
    Table1DEPTH: TSmallintField;
    Table1BACKGROUND: TIntegerField;
    Table1METHOD: TStringField;
    Table1NAME: TStringField;
    Table1IMAGE: TGraphicField;
    DataSource1: TDataSource;
    Table1: TTable;
    Table1KEY: TAutoIncField;
    procedure CheckEditBeforePost(DataSet: TDataSet);
  private
    { private declarations }
  public
    procedure DataModuleInit(Sender: TObject);{ public declarations }
    procedure DataModuleNew(Sender: TObject);{ public declarations }
  end;

implementation

uses
  mandbr;

{$R *.DFM}

{================================================================}
procedure TDataModule1.DataModuleInit(Sender: TObject);
begin
  Table1.AddIndex('KEYIndex', 'KEY', [ixUnique,ixPrimary]);
  Table1.CachedUpdates := True;
  Table1.Open;
end;

{================================================================}
procedure TDataModule1.DataModuleNew(Sender: TObject);
begin
  Table1.CreateTable;
end;

{================================================================}
procedure TDataModule1.CheckEditBeforePost(DataSet: TDataSet);
var
  ErrorMsg : String;
  RetValue : Boolean;
begin
  RetValue   := True;
  ErrorMsg := '';

  if Table1X_0.Value >= Table1X_1.Value
  then begin
    ErrorMsg := ErrorMsg + #13#10 +
                'X_2 must be greater than X_1';
    RetValue := False;
  end;

  if Table1Y_0.Value >= Table1Y_1.Value
  then begin
    ErrorMsg := ErrorMsg + #13#10 +
                'Y_2 must be greater than Y_1';
    RetValue := False;
  end;

  if Table1DEPTH.Value <= 0
  then begin
    ErrorMsg := ErrorMsg + #13#10 +
                'DEPTH must be greater than 0';
    RetValue := False;
  end;

  if Table1STEP.Value <= 0
  then begin
    ErrorMsg := ErrorMsg + #13#10 +
                'STEP must be greater than 0';
    RetValue := False;
  end;

  if Table1THRESHOLD.Value < 0
  then begin
    ErrorMsg := ErrorMsg + #13#10 +
                'THRESHOLD must be greater than 0 or equal to 0';
    RetValue := False;
  end;

  if Table1THRESHOLD.Value >= Table1DEPTH.Value
  then begin
    ErrorMsg := ErrorMsg + #13#10 +
                'THRESHOLD must be less than DEPTH';
    RetValue := False;
  end;

  if Table1STEP.Value >
    (Table1DEPTH.Value - Table1THRESHOLD.Value)
  then begin
    ErrorMsg := ErrorMsg + #13#10 +
                'STEP must be less than DEPTH-THRESHOLD';
    RetValue := False;
  end;

  if not Is_AvMet(Table1METHOD.Value)
  then begin
    ErrorMsg := ErrorMsg + #13#10 + Get_AvMets;
    RetValue := False;
  end;

  if not RetValue
  then begin
    ErrorMsg := 'Invalid data:' + #13#10 + ErrorMsg;
    ShowMessage(ErrorMsg);
    Abort;
  end;

end;

end.