unit ExpForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, ExtCtrls, StdCtrls,
  front;

const Border = 2;

type
  DoubleStr = string[21];

  TFormExp = class(TForm)
    Panel: TPanel;
    Image: TImage;
    ShowBtn: TButton;
    EditBtn: TButton;
    SaveBtn: TButton;
    ExitBtn: TButton;
    LabCC: TLabel;
    LabXY: TLabel;
    LabNF: TLabel;
    LabRU: TLabel;
    LabLD: TLabel;
    LabCuL: TLabel;
    LabX0: TLabel;
    LabX1: TLabel;
    LabY0: TLabel;
    LabY1: TLabel;
    EditName: TEdit;
    procedure ExpActivateProc(Sender: TObject);
    procedure StartShow(Sender: TObject);
    procedure EditShow(Sender: TObject);
    procedure SaveShow(Sender: TObject);
    procedure ExitShow(Sender: TObject);
    procedure CloseExpForm(Sender: TObject; var Action: TCloseAction);
    procedure MouseDownProc(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MouseUpProc(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MouseMoveProc(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ExpCreateProc(Sender: TObject);
  private
    X_0, X_1, Y_0, Y_1 : Double;
    METHOD             : String;
    BACKGROUND         : TColor;
    DEPTH,
    THRESHOLD,
    STEP               : Integer;
    Modified           : Boolean;
    Frontiers          : Boolean;
    Showed             : Boolean;
    Painted            : Boolean;
    CX,   CY,
    NX_0, NX_1,
    NY_0, NY_1         : Integer;
    NDX_0, NDX_1,
    NDY_0, NDY_1       : Double;
    Front              : TFRONT;
    procedure ShowCC;
    procedure ShowNF;
    procedure DisplayNF;
    procedure ShowCL;
    procedure ShowButtons;
    procedure ResetFront;
    procedure ApplyFront;
    procedure RoundFront(var A0,A1 : Double);
    procedure TruncZeros(var S : DoubleStr);
  public
    Procedure Work;
    Procedure Init;
    Procedure HideFrontiers;
  end;

var
  FormExp: TFormExp;

implementation

uses
  Main, Childwin, mandbr, DataMod, EditImag, NameBox, DB;

{$R *.DFM}

{==================================================================}
procedure TFormExp.ExpActivateProc(Sender: TObject);
begin
  Top    := 0;
  Left   := 0;
  Height := Screen.Height;
  Width  := Screen.Width;
  Image.Top    := Panel.Top + Border;
  Image.Left   := Panel.Left + Border;
  Image.Height := Panel.Height - 2*Border;
  Image.Width  := Panel.Width - 2*Border;
  if Image.Height < Image.Width
    then Image.Width  := Image.Height
    else Image.Height := Image.Width;

  ShowBtn.Top    := Image.Top + Border;
  EditBtn.Top    := ShowBtn.Top + ShowBtn.Height + Border;
  SaveBtn.Top    := EditBtn.Top + EditBtn.Height + Border;
  ExitBtn.Top    := SaveBtn.Top + SaveBtn.Height + Border;
  LabCC.Top    := ExitBtn.Top + ExitBtn.Height + 3*Border;
  LabXY.Top    := LabCC.Top + LabCC.Height + Border;
  LabNF.Top    := LabXY.Top + LabXY.Height + 3*Border;
  LabLD.Top    := LabNF.Top + LabNF.Height + Border;
  LabRU.Top    := LabLD.Top + LabLD.Height + Border;
  LabCuL.Top   := LabRU.Top + LabRU.Height + 3*Border;
  LabX0.Top    := LabCuL.Top+ LabCuL.Height+ Border;
  LabX1.Top    := LabX0.Top + LabX0.Height + Border;
  LabY0.Top    := LabX1.Top + LabX1.Height + Border;
  LabY1.Top    := LabY0.Top + LabY0.Height + Border;

  ShowBtn.Left   := Image.Left + Image.Width + Border;
  EditBtn.Left   := ShowBtn.Left;
  SaveBtn.Left   := ShowBtn.Left;
  ExitBtn.Left   := ShowBtn.Left;
  LabCC.Left   := ShowBtn.Left;
  LabXY.Left   := ShowBtn.Left;
  LabNF.Left   := ShowBtn.Left;
  LabLD.Left   := ShowBtn.Left;
  LabRU.Left   := ShowBtn.Left;
  LabCuL.Left   := ShowBtn.Left;
  LabX0.Left    := ShowBtn.Left;
  LabX1.Left    := ShowBtn.Left;
  LabY0.Left    := ShowBtn.Left;
  LabY1.Left    := ShowBtn.Left;

  ShowBtn.Width   := Panel.Width -Image.Width - 3*Border;
  EditBtn.Width   := ShowBtn.Width;
  SaveBtn.Width   := ShowBtn.Width;
  ExitBtn.Width   := ShowBtn.Width;
  LabCC.Width   := ShowBtn.Width;
  LabXY.Width   := ShowBtn.Width;
  LabNF.Width   := ShowBtn.Width;
  LabLD.Width   := ShowBtn.Width;
  LabRU.Width   := ShowBtn.Width;
  LabCuL.Width   := ShowBtn.Width;
  LabX0.Width    := ShowBtn.Width;
  LabX1.Width    := ShowBtn.Width;
  LabY0.Width    := ShowBtn.Width;
  LabY1.Width    := ShowBtn.Width;

  Modified  := False;
  Frontiers := False;
  Showed    := False;
  Painted   := False;

  CX := 0;
  CY := 0;

end;

{==================================================================}
Procedure TFormExp.HideFrontiers;
begin
  Front.Hide;
  LabRU.Caption := '';
  LabLD.Caption := '';
  LabNF.Caption := '';
end;


{==================================================================}
Procedure TFormExp.Work;
begin
  Show;
  Init;
end;

{==================================================================}
Procedure TFormExp.Init;
var
  D_Module   : TDataModule1;
begin
  D_Module := (MainForm.ActiveMDIChild as TMDIChild).Is_D_Module;
  If not StartExplore
  then begin
    X_0 := D_Module.Table1X_0.Value;
    X_1 := D_Module.Table1X_1.Value;
    Y_0 := D_Module.Table1Y_0.Value;
    Y_1 := D_Module.Table1Y_1.Value;
    METHOD       := D_Module.Table1METHOD.Value;
    BACKGROUND   := D_Module.Table1BACKGROUND.Value;
    DEPTH        := D_Module.Table1DEPTH.Value;
    THRESHOLD    := D_Module.Table1THRESHOLD.Value;
    STEP         := D_Module.Table1STEP.Value;
  end
  else begin
    X_0 := -2.25;
    X_1 :=  0.75;
    Y_0 := -1.5;
    Y_1 :=  1.5;
    METHOD       := 'Old';
    BACKGROUND   := clBlack;
    DEPTH        := 100;
    THRESHOLD    := 10;
    STEP         := 1;
  end;
  ShowCL;
  Modified  := False;
  Showed    := False;
  Painted   := False;
  Frontiers := False;
  Front.Init(@Image);
  HideFrontiers;
  ShowButtons;
end;

{==================================================================}
procedure TFormExp.StartShow(Sender: TObject);
var
  Im_X, Im_Y : Integer;
  D_Y        : Integer;
  Man : TMANDELBROT;
begin
  if ( NDX_0<>0 ) or ( NDX_1<>0 ) or
     ( NDY_0<>0 ) or ( NDY_1<>0 )
  then begin
    case MessageDlg('Do You want to apply new frontiers before show?',
                     mtConfirmation, [mbYes, mbNo, mbCancel], 0
                   )
                   of
    mrYes : ApplyFront;
    mrNo  : ResetFront;
    mrCancel : Exit;
    end;
  end;

  ShowCL;
  Man := TMANDELBROT.Create;
  If not Man.Init(X_0,X_1,Y_0,Y_1,
                  Image.Width,
                  Image.Height,
                  METHOD, BACKGROUND,
                  DEPTH, THRESHOLD, STEP
                 )
    then ShowMessage('Cannot init this look.')
    else begin
      Screen.Cursor := crHourglass;
    try
      Modified := True;
      Front.Hide;
      Image.Canvas.Brush.Style := bsSolid;
      Image.Canvas.Brush.Color := BACKGROUND;
      Image.Canvas.FloodFill( Image.Width div 2,
                              Image.Height div 2,
                              clBlack,
                              fsBorder);
      Image.Canvas.FloodFill( Image.Width div 2,
                              Image.Height div 2,
                              clWhite,
                              fsBorder);
      Showed := True;
      Image.Repaint;
      Painted:= True;
      ShowButtons;

      D_Y := Image.Height - 1;
      for Im_X:= 0 to Image.Width  - 1
      do begin
        for Im_Y:= D_Y downto 0
        do begin
          Image.Canvas.Pixels[Im_X,D_Y-Im_Y] := Man.GetPixel(Im_X,Im_Y);
        end;
        Image.Repaint;
      end;
    finally
      Screen.Cursor := crDefault;
      Showed    := False;
      ShowButtons;
    end;
    end;
end;


{==================================================================}
procedure TFormExp.ResetFront;
begin
  If not Showed
  then begin
    HideFrontiers;
    Front.Hide;
    NX_0 := 0;
    NX_1 := 0;
    NY_0 := 0;
    NY_1 := 0;
    NDX_0 := 0;
    NDX_1 := 0;
    NDY_0 := 0;
    NDY_1 := 0;

    Frontiers := False;
  end;
  ShowButtons;
end;

{==================================================================}
procedure TFormExp.ApplyFront;
begin
  If not Showed
  then if ( NDX_0<>0 ) or ( NDX_1<>0 ) or
          ( NDY_0<>0 ) or ( NDY_1<>0 )
  then begin
    RoundFront(NDX_0,NDX_1);
    RoundFront(NDY_0,NDY_1);
    DisplayNF;
    X_0 := NDX_0;
    X_1 := NDX_1;
    Y_0 := NDY_0;
    Y_1 := NDY_1;
    ResetFront;
    ShowCL;
    Frontiers := False;
    ShowButtons;
  end;
end;

{==================================================================}
procedure TFormExp.RoundFront(var A0,A1 : Double);
const
  DIA = 3;
var
  Delta : Double;
  Count, I : Integer;
begin
  Delta := A1 - A0;
  Count := 0;
  while Delta < 1
  do begin
    Delta := Delta * 10;
    Inc(Count);
  end;
  Inc(Count,DIA);
  for I := 0 to Count
  do begin
    A0 := 10 * A0;
    A1 := 10 * A1;
  end;
  A0 := Int(A0);
  A1 := Int(A1);
  for I := 0 to Count
  do begin
    A0 := A0 / 10;
    A1 := A1 / 10;
  end;
end;



{==================================================================}
procedure TFormExp.EditShow(Sender: TObject);
begin
  if Showed then Exit;
  EditDlg.Init(METHOD,BACKGROUND,DEPTH,THRESHOLD,STEP);
  EditDlg.ShowModal;
  If EditDlg.Is_OK
  then begin
    Modified := True;
    EditDlg.ReInit(METHOD,BACKGROUND,DEPTH,THRESHOLD,STEP);
    ShowCL;
  end;
  ShowButtons;
end;

{==================================================================}
procedure TFormExp.SaveShow(Sender: TObject);
var
  D_Module   : TDataModule1;
  D_Child    : TMDIChild;
begin
  Screen.Cursor := crHourglass;
try
  D_Child  := MainForm.ActiveMDIChild as TMDIChild;
  D_Module := D_Child.Is_D_Module;

  if D_Module.Table1.State <> dsInsert
  then begin
    D_Child.DBNavigator.BtnClick(nbPost);
    D_Child.DBNavigator.BtnClick(nbInsert);
  end;

  D_Module := D_Child.Is_D_Module;
  D_Module.Table1X_0.Value := X_0;
  D_Module.Table1X_1.Value := X_1;
  D_Module.Table1Y_0.Value := Y_0;
  D_Module.Table1Y_1.Value := Y_1;
  D_Module.Table1METHOD.Value     := METHOD;
  D_Module.Table1BACKGROUND.Value := BACKGROUND;
  D_Module.Table1DEPTH.Value      := DEPTH;
  D_Module.Table1THRESHOLD.Value  := THRESHOLD;
  D_Module.Table1STEP.Value       := STEP;

  OKBottomDlg.Edit1.Text := D_Module.Table1NAME.Value;
  OKBottomDlg.ShowModal;
  If OKBottomDlg.ModalResult = mrOK
  then D_Module.Table1NAME.Value := OKBottomDlg.Edit1.Text;
  D_Child.RepaintClickProc(@self);

  D_Child.DBNavigator.BtnClick(nbPost);
  D_Child.DBNavigator.BtnClick(nbInsert);
  Modified := False;
finally
  Screen.Cursor := crDefault;
  ShowButtons;
end;
end;

{==================================================================}
procedure TFormExp.ExitShow(Sender: TObject);
begin
  Close;
end;

{==================================================================}
procedure TFormExp.CloseExpForm(Sender: TObject; var Action: TCloseAction);
begin
  if Modified
  then begin
    case MessageDlg('Do You want to save IMAGE before exit?',
                     mtConfirmation, [mbYes, mbNo, mbCancel], 0
                   )
                   of
      mrYes : begin
                SaveShow(self);
                Modified := False;
                Action := caHide;
              end;
      mrNo  : begin
                Modified := False;
                Action := caHide;
              end;
      mrCancel : Action := caNone;
    end;
  end
  else begin
    Action := caHide;
  end;
  StartExplore := False;
  If Action = caHide
  then begin
    Front.Hide;
    Painted:= False;
    Image.Canvas.Brush.Style := bsSolid;
    Image.Canvas.Brush.Color := BACKGROUND;
    Image.Canvas.FloodFill( Image.Width div 2,
                            Image.Height div 2,
                            clBlack,
                            fsBorder);
    Image.Canvas.FloodFill( Image.Width div 2,
                            Image.Height div 2,
                            clWhite,
                            fsBorder);
    Image.Repaint;

    MainForm.ActiveMDIChild.Enabled := True;
  end;
end;

{==================================================================}
procedure TFormExp.MouseDownProc(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Painted
  then begin
    ResetFront;
    NX_0 := X;
    NY_0 := Y;
    NX_1 := X;
    NY_1 := Y;
    Frontiers := True;
  end;
  ShowButtons;
end;

{==================================================================}
procedure TFormExp.MouseUpProc(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Frontiers := False;
  ShowButtons;
end;

{==================================================================}
procedure TFormExp.MouseMoveProc(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if (X<0) or (X>=Image.Width) or
     (Y<0) or (Y>=Image.Height) then Exit;
  CX := X;
  CY := Y;
  ShowCC;
  if Frontiers
  then begin
    NX_1 := X;
    NY_1 := Y;
    ShowNF;

  end;
end;

{==================================================================}
procedure TFormExp.ShowCC;
var
  StrX, StrY : DoubleStr;
  XX, YY     : Double;
begin
  XX := X_0 + CX/Image.Width  * (X_1-X_0);
  YY := Y_1 - CY/Image.Height * (Y_1-Y_0);
  Str(XX:20:10, StrX);
  Str(YY:20:10, StrY);
  LabXY.Caption := Trim(StrX) + ':' + Trim(StrY);
end;

{==================================================================}
procedure TFormExp.ShowNF;
var
  tmp                        : Double;
begin
  NDX_0 := X_0 + NX_0/Image.Width  * (X_1-X_0);
  NDX_1 := X_0 + NX_1/Image.Width  * (X_1-X_0);
  NDY_0 := Y_1 - NY_0/Image.Height * (Y_1-Y_0);
  NDY_1 := Y_1 - NY_1/Image.Height * (Y_1-Y_0);

  if NDX_1 < NDX_0
  then begin
    tmp   := NDX_1;
    NDX_1 := NDX_0;
    NDX_0 := tmp;
  end;

  if NDY_1 < NDY_0
  then begin
    tmp   := NDY_1;
    NDY_1 := NDY_0;
    NDY_0 := tmp;
  end;

  DisplayNF;

  If not Showed
  then begin
    if Front.Hide
    then begin
      if Front.SetFront(NX_0,NY_0,NX_1,NY_1)
      then if not Front.Show
      then ShowMessage('Cannot show new Frontiers.');
    end
    else ShowMessage('Cannot hide old Frontiers.');
  end;

end;
{==================================================================}
procedure TFormExp.DisplayNF;
var
  StrX, StrY                 : DoubleStr;
begin
  LabNF.Caption := '         New frontiers:';

  Str(NDX_0:20:10, StrX);
  Str(NDY_0:20:10, StrY);
  TruncZeros(StrX);
  TruncZeros(StrY);
  LabLD.Caption := 'LD '+Trim(StrX) + ':' + Trim(StrY)+
                   '                                  ';
  LabLD.Refresh;

  Str(NDX_1:20:10, StrX);
  Str(NDY_1:20:10, StrY);
  TruncZeros(StrX);
  TruncZeros(StrY);
  LabRU.Caption := 'RU'+Trim(StrX) + ':' + Trim(StrY)+
                   '                                 ';
  LabRU.Refresh;

end;

{==================================================================}
procedure TFormExp.ShowCL;
var
  StrX     : DoubleStr;
begin
  LabCuL.Caption := '          Current look:';

  Str(X_0:20:10, StrX);
  TruncZeros(StrX);
  LabX0.Caption := 'X0 = '+Trim(StrX);
  Str(Y_0:20:10, StrX);
  TruncZeros(StrX);
  LabY0.Caption := 'Y0 = '+Trim(StrX);
  Str(X_1:20:10, StrX);
  TruncZeros(StrX);
  LabX1.Caption := 'X1 = '+Trim(StrX);
  Str(Y_1:20:10, StrX);
  TruncZeros(StrX);
  LabY1.Caption := 'Y1 = '+Trim(StrX);

end;

{==================================================================}
procedure TFormExp.ExpCreateProc(Sender: TObject);
begin
  Front := TFRONT.Create;
end;

{==================================================================}
procedure TFormExp.ShowButtons;
begin
    ShowBtn.Enabled := True;
    EditBtn.Enabled := not Showed;
    SaveBtn.Enabled := not Showed and Modified;
    ExitBtn.Enabled := not Showed;
end;

{==================================================================}
procedure  TFormExp.TruncZeros(var S : DoubleStr);
var
  i : Integer;
begin
  for i:=Length(S) downto 1
  do if S[i]='0' then S[i]:=' '
                 else break;
end;

end.
