unit front;

interface

uses
  Graphics, ExtCtrls, Windows, SysUtils, Dialogs;

type

ImagePtr = ^TImage;

TFRONT = class
private
    x0, y0, x1, y1 : Integer;
    visible        : Boolean;
    image          : ImagePtr;
public
    Constructor Create;
    Function Init( Im_ptr : ImagePtr)            : Boolean;
    Function SetFront(x0_,y0_,x1_,y1_ : Integer) : Boolean;
    Function Show                                : Boolean;
    Function Hide                                : Boolean;
end;

implementation

{==================================================}
Constructor TFRONT.Create;
begin
  x0 := 0;
  x1 := 0;
  y0 := 0;
  y1 := 0;
  visible  := False;
  image    := Nil;
end;

{==================================================}
Function TFRONT.Init( Im_ptr : ImagePtr) : Boolean;
begin
  if Im_ptr <> Nil
  then begin
    Init := True;
    image := Im_ptr;
  end
  else Init := False;
end;

{==================================================}
Function TFRONT.SetFront(x0_,y0_,x1_,y1_ : Integer) : Boolean;
var
  tmp : Integer;
begin
  if x0_>x1_
  then begin
    tmp := x0_;
    x0_ := x1_;
    x1_ := tmp;
  end;

  if y0_>y1_
  then begin
    tmp := y0_;
    y0_ := y1_;
    y1_ := tmp;
  end;

  if (image <> Nil) and
     (x0_ >= 0) and (x0_ <= x1_) and
     (y0_ >= 0) and (y0_ <= y1_) and
     (x1_ < image^.Width)  and
     (y1_ < image^.Height)
  then begin
    x0 := x0_;
    x1 := x1_;
    y0 := y0_;
    y1 := y1_;
    SetFront := True;
  end
  else begin
    SetFront := False;
  end;
end;

{==================================================}
Function TFRONT.Show : Boolean;
var
  Old_W  : Integer;
  Old_M  : TPenMode;
begin
  Old_W  := image^.Canvas.Pen.Width;
  Old_M  := image^.Canvas.Pen.Mode;
  Show := True;
  visible := True;
  image^.Canvas.Pen.Width := 3;
  image^.Canvas.Pen.Mode := pmNot;
  image^.Canvas.MoveTo(x0, y0);
  image^.Canvas.LineTo(x1, y0);
  image^.Canvas.LineTo(x1, y1);
  image^.Canvas.LineTo(x0, y1);
  image^.Canvas.LineTo(x0, y0);
  image^.Canvas.Pen.Width := Old_W;
  image^.Canvas.Pen.Mode  := Old_M;
end;

{==================================================}
Function TFRONT.Hide : Boolean;
begin
  Hide := True;
  if visible
  then if Show then visible := False;
end;

end.
